Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -1487,149 +1012,185 @@
     ELSEIF ( bc_uv_b == 'neumann' )  THEN
        ibc_uv_b = 1
-       IF ( constant_flux_layer )  THEN
-          message_string = 'boundary condition: bc_uv_b = "' // TRIM( bc_uv_b ) //                 &
-                           '" is not allowed with constant_flux_layer = .TRUE.'
-          CALL message( 'check_parameters', 'PA0075', 1, 2, 0, 6, 0 )
+       IF ( prandtl_layer )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters:'
+             PRINT*, '    boundary condition: bc_uv_b = ', TRIM( bc_uv_b ), &
+                          ' is not allowed with'
+             PRINT*, '    prandtl_layer = .TRUE.' 
+          ENDIF
+          CALL local_stop
        ENDIF
     ELSE
-       message_string = 'unknown boundary condition: bc_uv_b = "' // TRIM( bc_uv_b ) // '"'
-       CALL message( 'check_parameters', 'PA0076', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- In case of coupled simulations u and v at the ground in atmosphere will be assigned with the u
-!-- and v values of the ocean surface
-    IF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
-       ibc_uv_b = 2
-    ENDIF
-
-    IF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
-       bc_uv_t = 'neumann'
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    unknown boundary condition: bc_uv_b = ', bc_uv_b
+       ENDIF
+       CALL local_stop
+    ENDIF
+    IF ( bc_uv_t == 'dirichlet' )  THEN
+       ibc_uv_t = 0
+    ELSEIF ( bc_uv_t == 'neumann' )  THEN
        ibc_uv_t = 1
     ELSE
-       IF ( bc_uv_t == 'dirichlet' .OR. bc_uv_t == 'dirichlet_0' )  THEN
-          ibc_uv_t = 0
-          IF ( bc_uv_t == 'dirichlet_0' )  THEN
-!
-!--          Velocities for the initial u,v-profiles are set zero at the top in case of dirichlet_0
-!--          conditions
-             u_init(nzt+1)    = 0.0_wp
-             v_init(nzt+1)    = 0.0_wp
-          ENDIF
-       ELSEIF ( bc_uv_t == 'neumann' )  THEN
-          ibc_uv_t = 1
-       ELSEIF ( bc_uv_t == 'nested'  .OR.  bc_uv_t == 'nesting_offline' )  THEN
-          ibc_uv_t = 3
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    unknown boundary condition: bc_uv_t = ', bc_uv_t
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+!
+!-- Compute and check, respectively, the Rayleigh Damping parameter
+    IF ( rayleigh_damping_factor == -1.0 )  THEN
+       IF ( momentum_advec == 'ups-scheme' )  THEN
+          rayleigh_damping_factor = 0.01
        ELSE
-          message_string = 'unknown boundary condition: bc_uv_t = "' // TRIM( bc_uv_t ) // '"'
-          CALL message( 'check_parameters', 'PA0077', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-
-!
-!-- Compute and check, respectively, the Rayleigh Damping parameter
-    IF ( rayleigh_damping_factor == -1.0_wp )  THEN
-       rayleigh_damping_factor = 0.0_wp
+          rayleigh_damping_factor = 0.0
+       ENDIF
     ELSE
-       IF ( rayleigh_damping_factor < 0.0_wp  .OR.  rayleigh_damping_factor > 1.0_wp )  THEN
-          WRITE( message_string, * )  'rayleigh_damping_factor = ', rayleigh_damping_factor,       &
-                 ' out of range [0.0,1.0]'
-          CALL message( 'check_parameters', 'PA0078', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-
-    IF ( rayleigh_damping_height == -1.0_wp )  THEN
-       IF ( .NOT. ocean_mode )  THEN
-          rayleigh_damping_height = 0.66666666666_wp * zu(nzt)
-       ELSE
-          rayleigh_damping_height = 0.66666666666_wp * zu(nzb)
-       ENDIF
+       IF ( rayleigh_damping_factor < 0.0 .OR. rayleigh_damping_factor > 1.0 ) &
+       THEN
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters:'
+             PRINT*, '    rayleigh_damping_factor = ', rayleigh_damping_factor,&
+                          ' out of range [0.0,1.0]'
+          ENDIF
+          CALL local_stop
+       ENDIF
+    ENDIF
+
+    IF ( rayleigh_damping_height == -1.0 )  THEN
+       rayleigh_damping_height = 0.66666666666 * zu(nzt)
     ELSE
-       IF ( .NOT. ocean_mode )  THEN
-          IF ( rayleigh_damping_height < 0.0_wp  .OR.  rayleigh_damping_height > zu(nzt) )  THEN
-             WRITE( message_string, * )  'rayleigh_damping_height = ',  rayleigh_damping_height,   &
-                    ' out of range [0.0,', zu(nzt), ']'
-             CALL message( 'check_parameters', 'PA0079', 1, 2, 0, 6, 0 )
-          ENDIF
-       ELSE
-          IF ( rayleigh_damping_height > 0.0_wp  .OR.  rayleigh_damping_height < zu(nzb) )  THEN
-             WRITE( message_string, * )  'rayleigh_damping_height = ', rayleigh_damping_height,    &
-                    ' out of range [0.0,', zu(nzb), ']'
-             CALL message( 'check_parameters', 'PA0079', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-    ENDIF
-
-!
-!-- Check number of chosen statistic regions
-    IF ( statistic_regions < 0 )  THEN
-       WRITE ( message_string, * ) 'number of statistic_regions = ', statistic_regions+1,          &
-               ' is not allowed'
-       CALL message( 'check_parameters', 'PA0082', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( normalizing_region > statistic_regions  .OR.  normalizing_region < 0)  THEN
-       WRITE ( message_string, * ) 'normalizing_region = ', normalizing_region,                    &
-               ' must be >= 0 and <= ',statistic_regions, ' (value of statistic_regions)'
-       CALL message( 'check_parameters', 'PA0083', 1, 2, 0, 6, 0 )
+       IF ( rayleigh_damping_height < 0.0  .OR. &
+            rayleigh_damping_height > zu(nzt) )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters:'
+             PRINT*, '    rayleigh_damping_height = ', rayleigh_damping_height,&
+                          ' out of range [0.0,', zu(nzt), ']'
+          ENDIF
+          CALL local_stop
+       ENDIF
+    ENDIF
+
+!
+!-- Check limiters for Upstream-Spline scheme
+    IF ( overshoot_limit_u < 0.0  .OR.  overshoot_limit_v < 0.0  .OR.  &
+         overshoot_limit_w < 0.0  .OR.  overshoot_limit_pt < 0.0  .OR. &
+         overshoot_limit_e < 0.0 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    overshoot_limit_... < 0.0 is not allowed'
+       ENDIF
+       CALL local_stop
+    ENDIF
+    IF ( ups_limit_u < 0.0 .OR. ups_limit_v < 0.0 .OR. ups_limit_w < 0.0 .OR. &
+         ups_limit_pt < 0.0 .OR. ups_limit_e < 0.0 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    ups_limit_... < 0.0 is not allowed'
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+!
+!-- Check number of chosen statistic regions. More than 10 regions are not
+!-- allowed, because so far no more than 10 corresponding output files can
+!-- be opened (cf. check_open)
+    IF ( statistic_regions > 9  .OR.  statistic_regions < 0 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: Number of statistic_regions = ', &
+                       statistic_regions+1
+          PRINT*, '    Only 10 regions are allowed'
+       ENDIF
+       CALL local_stop
+    ENDIF
+    IF ( normalizing_region > statistic_regions  .OR. &
+         normalizing_region < 0)  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: normalizing_region = ', &
+                       normalizing_region, ' is unknown'
+          PRINT*, '    Must be <= ', statistic_regions
+       ENDIF
+       CALL local_stop
     ENDIF
 
 !
 !-- Set the default intervals for data output, if necessary
-!-- NOTE: dt_dosp has already been set in spectra_parin
-    IF ( dt_data_output /= 9999999.9_wp )  THEN
-       IF ( dt_dopr           == 9999999.9_wp )  dt_dopr           = dt_data_output
-       IF ( dt_dopts          == 9999999.9_wp )  dt_dopts          = dt_data_output
-       IF ( dt_do2d_xy        == 9999999.9_wp )  dt_do2d_xy        = dt_data_output
-       IF ( dt_do2d_xz        == 9999999.9_wp )  dt_do2d_xz        = dt_data_output
-       IF ( dt_do2d_yz        == 9999999.9_wp )  dt_do2d_yz        = dt_data_output
-       IF ( dt_do3d           == 9999999.9_wp )  dt_do3d           = dt_data_output
-       IF ( dt_data_output_av == 9999999.9_wp )  dt_data_output_av = dt_data_output
-       DO  mid = 1, max_masks
-          IF ( dt_domask(mid) == 9999999.9_wp )  dt_domask(mid)    = dt_data_output
-       ENDDO
+!-- NOTE: dt_dosp has already been set in package_parin
+    IF ( dt_data_output /= 9999999.9 )  THEN
+       IF ( dt_dopr           == 9999999.9 )  dt_dopr           = dt_data_output
+       IF ( dt_dopts          == 9999999.9 )  dt_dopts          = dt_data_output
+       IF ( dt_do2d_xy        == 9999999.9 )  dt_do2d_xy        = dt_data_output
+       IF ( dt_do2d_xz        == 9999999.9 )  dt_do2d_xz        = dt_data_output
+       IF ( dt_do2d_yz        == 9999999.9 )  dt_do2d_yz        = dt_data_output
+       IF ( dt_do3d           == 9999999.9 )  dt_do3d           = dt_data_output
+       IF ( dt_data_output_av == 9999999.9 )  dt_data_output_av = dt_data_output
     ENDIF
 
 !
 !-- Set the default skip time intervals for data output, if necessary
-    IF ( skip_time_dopr    == 9999999.9_wp )  skip_time_dopr    = skip_time_data_output
-    IF ( skip_time_do2d_xy == 9999999.9_wp )  skip_time_do2d_xy = skip_time_data_output
-    IF ( skip_time_do2d_xz == 9999999.9_wp )  skip_time_do2d_xz = skip_time_data_output
-    IF ( skip_time_do2d_yz == 9999999.9_wp )  skip_time_do2d_yz = skip_time_data_output
-    IF ( skip_time_do3d    == 9999999.9_wp )  skip_time_do3d    = skip_time_data_output
-    IF ( skip_time_data_output_av == 9999999.9_wp )                                                &
-                                       skip_time_data_output_av = skip_time_data_output
-    DO  mid = 1, max_masks
-       IF ( skip_time_domask(mid) == 9999999.9_wp )                                                &
-                                       skip_time_domask(mid)    = skip_time_data_output
-    ENDDO
-
-!
-!-- Check the average intervals (first for 3d-data, then for profiles)
+    IF ( skip_time_dopr    == 9999999.9 ) &
+                                       skip_time_dopr    = skip_time_data_output
+    IF ( skip_time_dosp    == 9999999.9 ) &
+                                       skip_time_dosp    = skip_time_data_output
+    IF ( skip_time_do2d_xy == 9999999.9 ) &
+                                       skip_time_do2d_xy = skip_time_data_output
+    IF ( skip_time_do2d_xz == 9999999.9 ) &
+                                       skip_time_do2d_xz = skip_time_data_output
+    IF ( skip_time_do2d_yz == 9999999.9 ) &
+                                       skip_time_do2d_yz = skip_time_data_output
+    IF ( skip_time_do3d    == 9999999.9 ) &
+                                       skip_time_do3d    = skip_time_data_output
+    IF ( skip_time_data_output_av == 9999999.9 ) &
+                                skip_time_data_output_av = skip_time_data_output
+
+!
+!-- Check the average intervals (first for 3d-data, then for profiles and
+!-- spectra)
     IF ( averaging_interval > dt_data_output_av )  THEN
-       WRITE( message_string, * )  'averaging_interval = ', averaging_interval,                    &
-              ' must be <= dt_data_output_av = ', dt_data_output_av
-       CALL message( 'check_parameters', 'PA0085', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( averaging_interval_pr == 9999999.9_wp )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: average_interval=',              &
+                       averaging_interval, ' must be <= dt_data_output=', &
+                       dt_data_output
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+    IF ( averaging_interval_pr == 9999999.9 )  THEN
        averaging_interval_pr = averaging_interval
     ENDIF
 
     IF ( averaging_interval_pr > dt_dopr )  THEN
-       WRITE( message_string, * )  'averaging_interval_pr = ', averaging_interval_pr,              &
-              ' must be <= dt_dopr = ', dt_dopr
-       CALL message( 'check_parameters', 'PA0086', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: averaging_interval_pr=', &
+                       averaging_interval_pr, ' must be <= dt_dopr=', dt_dopr
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+    IF ( averaging_interval_sp == 9999999.9 )  THEN
+       averaging_interval_sp = averaging_interval
+    ENDIF
+
+    IF ( averaging_interval_sp > dt_dosp )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: averaging_interval_sp=', &
+                       averaging_interval_sp, ' must be <= dt_dosp=', dt_dosp
+       ENDIF
+       CALL local_stop
     ENDIF
 
 !
 !-- Set the default interval for profiles entering the temporal average
-    IF ( dt_averaging_input_pr == 9999999.9_wp )  THEN
+    IF ( dt_averaging_input_pr == 9999999.9 )  THEN
        dt_averaging_input_pr = dt_averaging_input
     ENDIF
 
 !
-!-- Set the default interval for the output of timeseries to a reasonable value (tries to minimize
-!-- the number of calls of flow_statistics)
-    IF ( dt_dots == 9999999.9_wp )  THEN
-       IF ( averaging_interval_pr == 0.0_wp )  THEN
+!-- Set the default interval for the output of timeseries to a reasonable
+!-- value (tries to minimize the number of calls of flow_statistics)
+    IF ( dt_dots == 9999999.9 )  THEN
+       IF ( averaging_interval_pr == 0.0 )  THEN
           dt_dots = MIN( dt_run_control, dt_dopr )
        ELSE
@@ -1641,23 +1202,25 @@
 !-- Check the sample rate for averaging (first for 3d-data, then for profiles)
     IF ( dt_averaging_input > averaging_interval )  THEN
-       WRITE( message_string, * )  'dt_averaging_input = ', dt_averaging_input,                    &
-              ' must be <= averaging_interval = ', averaging_interval
-       CALL message( 'check_parameters', 'PA0088', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: dt_averaging_input=',                &
+                       dt_averaging_input, ' must be <= averaging_interval=', &
+                       averaging_interval
+       ENDIF
+       CALL local_stop
     ENDIF
 
     IF ( dt_averaging_input_pr > averaging_interval_pr )  THEN
-       WRITE( message_string, * )  'dt_averaging_input_pr = ', dt_averaging_input_pr,              &
-              ' must be <= averaging_interval_pr = ', averaging_interval_pr
-       CALL message( 'check_parameters', 'PA0089', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check data-output variable list for any duplicates and remove them
-    ALLOCATE( data_output_filtered(1:UBOUND( data_output_pr, DIM=1 )) )
-    CALL filter_duplicate_strings( varnamelength, data_output_pr, data_output_filtered )
-    data_output_pr = data_output_filtered
-    DEALLOCATE( data_output_filtered )
-!
-!-- Determine the number of output profiles and check whether they are permissible
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters: dt_averaging_input_pr=', &
+                       dt_averaging_input_pr,                     &
+                       ' must be <= averaging_interval_pr=',      &
+                       averaging_interval_pr
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+!
+!-- Determine the number of output profiles and check whether they are
+!-- permissible
     DO  WHILE ( data_output_pr(dopr_n+1) /= '          ' )
 
@@ -1666,18 +1229,10 @@
 
 !
-!--    Size check. Some arrays in the netcdf interface module are internally limited to 500 elements
-!--    and would need to be increased for output of more than 500 profiles.
-       IF ( dopr_n > 500 )  THEN
-          message_string = 'output of more than 500 profiles requested'
-          CALL message( 'check_parameters', 'PA0017', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    Determine internal profile number (for hom, homs) and store height levels
+!--    Determine internal profile number (for hom, homs)
+!--    and store height levels
        SELECT CASE ( TRIM( data_output_pr(i) ) )
 
           CASE ( 'u', '#u' )
              dopr_index(i) = 1
-             dopr_unit(i)  = 'm/s'
              hom(:,2,1,:)  = SPREAD( zu, 2, statistic_regions+1 )
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
@@ -1689,6 +1244,5 @@
           CASE ( 'v', '#v' )
              dopr_index(i) = 2
-             dopr_unit(i)  = 'm/s'
-             hom(:,2,2,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             hom(:,2,2,:) = SPREAD( zu, 2, statistic_regions+1 )
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 6
@@ -1699,46 +1253,36 @@
           CASE ( 'w' )
              dopr_index(i) = 3
-             dopr_unit(i)  = 'm/s'
-             hom(:,2,3,:)  = SPREAD( zw, 2, statistic_regions+1 )
-
-          CASE ( 'theta', '#theta' )
-             IF ( .NOT. bulk_cloud_model )  THEN
+             hom(:,2,3,:) = SPREAD( zw, 2, statistic_regions+1 )
+
+          CASE ( 'pt', '#pt' )
+             IF ( .NOT. cloud_physics ) THEN
                 dopr_index(i) = 4
-                dopr_unit(i)  = 'K'
                 hom(:,2,4,:)  = SPREAD( zu, 2, statistic_regions+1 )
                 IF ( data_output_pr(i)(1:1) == '#' )  THEN
                    dopr_initial_index(i) = 7
                    hom(:,2,7,:)          = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,7,:)        = 0.0_wp    ! because zu(nzb) is negative
+                   hom(nzb,2,7,:)        = 0.0    ! weil zu(nzb) negativ ist
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
              ELSE
                 dopr_index(i) = 43
-                dopr_unit(i)  = 'K'
                 hom(:,2,43,:)  = SPREAD( zu, 2, statistic_regions+1 )
                 IF ( data_output_pr(i)(1:1) == '#' )  THEN
                    dopr_initial_index(i) = 28
                    hom(:,2,28,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,28,:)       = 0.0_wp    ! because zu(nzb) is negative
+                   hom(nzb,2,28,:)       = 0.0    ! weil zu(nzb) negativ ist
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
              ENDIF
 
-          CASE ( 'e', '#e' )
+          CASE ( 'e' )
              dopr_index(i)  = 8
-             dopr_unit(i)   = 'm2/s2'
              hom(:,2,8,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,8,:) = 0.0_wp
-             IF ( data_output_pr(i)(1:1) == '#' )  THEN
-                dopr_initial_index(i) = 8
-                hom(:,2,8,:)          = SPREAD( zu, 2, statistic_regions+1 )
-                data_output_pr(i)     = data_output_pr(i)(2:)
-             ENDIF
+             hom(nzb,2,8,:) = 0.0
 
           CASE ( 'km', '#km' )
              dopr_index(i)  = 9
-             dopr_unit(i)   = 'm2/s'
              hom(:,2,9,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,9,:) = 0.0_wp
+             hom(nzb,2,9,:) = 0.0
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 23
@@ -1749,7 +1293,6 @@
           CASE ( 'kh', '#kh' )
              dopr_index(i)   = 10
-             dopr_unit(i)    = 'm2/s'
              hom(:,2,10,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,10,:) = 0.0_wp
+             hom(nzb,2,10,:) = 0.0
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 24
@@ -1760,7 +1303,6 @@
           CASE ( 'l', '#l' )
              dopr_index(i)   = 11
-             dopr_unit(i)    = 'm'
              hom(:,2,11,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,11,:) = 0.0_wp
+             hom(nzb,2,11,:) = 0.0
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 25
@@ -1771,129 +1313,105 @@
           CASE ( 'w"u"' )
              dopr_index(i) = 12
-             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,12,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( constant_flux_layer )  hom(nzb,2,12,:) = zu(1)
+             IF ( prandtl_layer )  hom(nzb,2,12,:) = zu(1)
 
           CASE ( 'w*u*' )
              dopr_index(i) = 13
-             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,13,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w"v"' )
              dopr_index(i) = 14
-             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,14,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( constant_flux_layer )  hom(nzb,2,14,:) = zu(1)
+             IF ( prandtl_layer )  hom(nzb,2,14,:) = zu(1)
 
           CASE ( 'w*v*' )
              dopr_index(i) = 15
-             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,15,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'w"theta"' )
+          CASE ( 'w"pt"' )
              dopr_index(i) = 16
-             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,16,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'w*theta*' )
+          CASE ( 'w*pt*' )
              dopr_index(i) = 17
-             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,17,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'wtheta' )
+          CASE ( 'wpt' )
              dopr_index(i) = 18
-             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,18,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'wu' )
              dopr_index(i) = 19
-             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,19,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( constant_flux_layer )  hom(nzb,2,19,:) = zu(1)
+             IF ( prandtl_layer )  hom(nzb,2,19,:) = zu(1)
 
           CASE ( 'wv' )
              dopr_index(i) = 20
-             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,20,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( constant_flux_layer )  hom(nzb,2,20,:) = zu(1)
-
-          CASE ( 'w*theta*BC' )
+             IF ( prandtl_layer )  hom(nzb,2,20,:) = zu(1)
+
+          CASE ( 'w*pt*BC' )
              dopr_index(i) = 21
-             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,21,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'wthetaBC' )
+          CASE ( 'wptBC' )
              dopr_index(i) = 22
-             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,22,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'u*2' )
              dopr_index(i) = 30
-             dopr_unit(i)  = 'm2/s2'
              hom(:,2,30,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'v*2' )
              dopr_index(i) = 31
-             dopr_unit(i)  = 'm2/s2'
              hom(:,2,31,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'w*2' )
              dopr_index(i) = 32
-             dopr_unit(i)  = 'm2/s2'
              hom(:,2,32,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'theta*2' )
+          CASE ( 'pt*2' )
              dopr_index(i) = 33
-             dopr_unit(i)  = 'K2'
              hom(:,2,33,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'e*' )
              dopr_index(i) = 34
-             dopr_unit(i)  = 'm2/s2'
              hom(:,2,34,:) = SPREAD( zu, 2, statistic_regions+1 )
 
-          CASE ( 'w*2theta*' )
+          CASE ( 'w*2pt*' )
              dopr_index(i) = 35
-             dopr_unit(i)  = 'K m2/s2'
              hom(:,2,35,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'w*theta*2' )
+          CASE ( 'w*pt*2' )
              dopr_index(i) = 36
-             dopr_unit(i)  = 'K2 m/s'
              hom(:,2,36,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w*e*' )
              dopr_index(i) = 37
-             dopr_unit(i)  = 'm3/s3'
              hom(:,2,37,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w*3' )
              dopr_index(i) = 38
-             dopr_unit(i)  = 'm3/s3'
              hom(:,2,38,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'Sw' )
              dopr_index(i) = 39
-             dopr_unit(i)  = 'none'
              hom(:,2,39,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'p' )
-             dopr_index(i) = 40
-             dopr_unit(i)  = 'Pa'
-             hom(:,2,40,:) = SPREAD( zu, 2, statistic_regions+1 )
-
           CASE ( 'q', '#q' )
-             IF ( .NOT. humidity )  THEN
-                message_string = 'data_output_pr = ' // TRIM( data_output_pr(i) ) //               &
-                                 ' is not implemented for humidity = .FALSE.'
-                CALL message( 'check_parameters', 'PA0092', 1, 2, 0, 6, 0 )
+             IF ( .NOT. cloud_physics )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters:  data_output_pr = ', &
+                           data_output_pr(i),                          &
+                           '    is not implemented for cloud_physics = FALSE'
+                ENDIF
+                CALL local_stop
              ELSE
                 dopr_index(i) = 41
-                dopr_unit(i)  = 'kg/kg'
-                hom(:,2,41,:) = SPREAD( zu, 2, statistic_regions+1 )
+                hom(:,2,41,:)  = SPREAD( zu, 2, statistic_regions+1 )
                 IF ( data_output_pr(i)(1:1) == '#' )  THEN
                    dopr_initial_index(i) = 26
                    hom(:,2,26,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,26,:)       = 0.0_wp    ! because zu(nzb) is negative
+                   hom(nzb,2,26,:)       = 0.0    ! weil zu(nzb) negativ ist
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
